package com.iamberry.wechat.service.mapper;

import com.iamberry.wechat.core.entity.member.Member;
import java.util.List;

/**
 * 会员信息 mapper
 * 2016年4月21日
 * @author Administrator
 *
 */
public interface MemberMapper {
	/**
	 * 根据 userid 查询一个member
	 * 2016年4月21日
	 * @return
	 */
	Member getMemberByUserId(Integer userId);
	/**
	 * 根据 openid 查询一个member
	 * 2016年4月28日
	 * @author 穆再兴
	 * @return
	 */
	public Member getMemberByUserOpenId(String openid);
	/**
	 * 获取所有用户数量 
	 * @return
	 */
	Integer getCount();

	/**
	 * 修改用可用积分
	 * @param member
	 * @return
	 */
	public Integer updateUserIntegral(Member member);
	
	/**
	 * 根据 userid 修改会员信息
	 * 2016年4月21日
	 * @author 穆再兴
	 * @return
	 */
	public Integer updateMemberByUserId(Member member);
	
	/**
	 * 修改用户已用积分
	 * @param member
	 * @return
	 */
	public Integer updateUserUseIntegral(Member member);
	

	/**
	 * 获取个人信息
	 * @return
	 */
	Member getMyMemberInfo(String userOpenid);

	/**
	 * 修改个人信息
	 * @param member
	 * @return
	 */
	Integer updateMyMember(Member member);

	/**
	 * 修改数据
	 * @param  member
	 * @return Integer
	 */
	Integer update(Member member);


	List<Member> listMemberPage(Member member);

	/**
	 * 修改
	 * @return
	 */
	public Integer nowUpdateUserByOpenId(Member member);
}
