package com.iamberry.wechat.service.member;

import com.github.pagehelper.PageHelper;
import com.iamberry.app.tool.log.RatFWLogger;
import com.iamberry.wechat.core.entity.member.Member;
import com.iamberry.wechat.core.entity.page.PageRequest;
import com.iamberry.wechat.core.entity.page.PagedResult;
import com.iamberry.wechat.face.member.MemberService;
import com.iamberry.wechat.service.mapper.MemberMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import util.PageUtil;

import java.util.List;

/**
 * 会员信息 service 实现
 * 2016年4月21日
 * @author Administrator
 *
 */
@Service
public class MemberServiceImpl implements MemberService {
	@Autowired
	private MemberMapper memberMapper;
	@Autowired
	private RatFWLogger log;
	/**
	 * 根据userid得到会员信息
	 * @param userId
	 * @return
	 */
	@Override
	public Member getMemberByUserId(Integer userId) {
		return memberMapper.getMemberByUserId(userId);
	}

	@Override
	public Member getMemberByUserOpenId(String openid){
		return memberMapper.getMemberByUserOpenId(openid);
	}

	@Override
	public Integer updateMemberByUserId(Member member){
		return memberMapper.updateMemberByUserId(member);
	}

	@Override
	public Member getMyMemberInfo(String openId){
		Member member=memberMapper.getMyMemberInfo(openId);
		return member;
	}

	@Override
	public Integer updateMyMember(Member member) {
		return memberMapper.updateMyMember(member);
	}


	@Override
	public PagedResult<Member> listMemberPage(PageRequest<Member> pageRequest) {
		PageHelper.startPage(pageRequest.getPageNO(), pageRequest.getPageSize(), pageRequest.isPageTotal());
		List<Member> detedctList = memberMapper.listMemberPage(pageRequest.getData());
		return PageUtil.getPage(detedctList);
	}

	@Override
	public Integer nowUpdateUserByOpenId(Member member) {
		return memberMapper.nowUpdateUserByOpenId(member);
	}
}
